#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_GiantSharkImmediateDecapitation.h"
std::auto_ptr<Fish_GiantSharkImmediateDecapitation> Fish_GiantSharkImmediateDecapitation::msSingleton(nullptr);

int Fish_GiantSharkImmediateDecapitation::GetCount()
{
	return (int)mMapData.size();
}

const Fish_GiantSharkImmediateDecapitationData* Fish_GiantSharkImmediateDecapitation::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_GiantSharkImmediateDecapitationData>& Fish_GiantSharkImmediateDecapitation::GetMapData()
{
	return mMapData;
}

void Fish_GiantSharkImmediateDecapitation::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_GiantSharkImmediateDecapitation.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_GiantSharkImmediateDecapitationData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mMinimumIntegral = element->IntAttribute("MinimumIntegral");
		data.mMaximumIntegral = element->IntAttribute("MaximumIntegral");
		data.mDismantlingWeight = element->IntAttribute("DismantlingWeight");
		data.mLeopardWeight = element->IntAttribute("LeopardWeight");
		data.mGold = element->IntAttribute("Gold");
		data.mAdditionalRewards = element->IntAttribute("AdditionalRewards");
		data.mRewardCard = element->IntAttribute("RewardCard");
		data.mDisplayCardType = element->Attribute("DisplayCardType");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_GiantSharkImmediateDecapitation Loaded. Load Data:%u", mMapData.size());
}

void Fish_GiantSharkImmediateDecapitation::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_GiantSharkImmediateDecapitation");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_GiantSharkImmediateDecapitation");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_GiantSharkImmediateDecapitationData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readInt(L, "MinimumIntegral", data.mMinimumIntegral);
		LuaCfgHelper::readInt(L, "MaximumIntegral", data.mMaximumIntegral);
		LuaCfgHelper::readInt(L, "DismantlingWeight", data.mDismantlingWeight);
		LuaCfgHelper::readInt(L, "LeopardWeight", data.mLeopardWeight);
		LuaCfgHelper::readInt(L, "Gold", data.mGold);
		LuaCfgHelper::readInt(L, "AdditionalRewards", data.mAdditionalRewards);
		LuaCfgHelper::readInt(L, "RewardCard", data.mRewardCard);
		LuaCfgHelper::readString(L, "DisplayCardType", data.mDisplayCardType);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_GiantSharkImmediateDecapitation Loaded. Load Data:%u", mMapData.size());
}

void Fish_GiantSharkImmediateDecapitation::Reload()
{
	mMapData.clear();
	Load();
}

Fish_GiantSharkImmediateDecapitation* Fish_GiantSharkImmediateDecapitation::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_GiantSharkImmediateDecapitation());
	}
	return msSingleton.get();
}

void Fish_GiantSharkImmediateDecapitation::Release()
{
	msSingleton.reset(nullptr);
}
